#include <bits/stdc++.h>

using namespace std;

int N, C, Q, L[200005], R[200005], br;
string s;

void N_jednak_C(){
    for(int i=1; i<=Q; i++){
        for(int j=L[i]-1; j<R[i]; j++){
            if(s[j]=='1'){s[j]='0';}
            else {s[j]='1';}
        }
        for(int j=0; j<N; j++){
            if(s[j]=='1'){br++;}
        }
        cout<<br<<endl;
        br=0;
    }
}

int main(){

scanf("%d%d%d", &N, &C, &Q);
cin>>s;
for(int i=1; i<=Q; i++){
    scanf("%d%d", &L[i], &R[i]);
}
if(N==C){
    N_jednak_C();
}

return 0;}